<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: sdio_func_driver struct Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>sdio_func_driver Struct Reference<br>
<small>
[<a class="el" href="group__fdriver.html">SDIO function driver API</a>]</small>
</h1><code>#include &lt;<a class="el" href="sdio__api_8h-source.html">sdio_api.h</a>&gt;</code>
<p>
<table border=0 cellpadding=0 cellspacing=0>
<tr><td></td></tr>
<tr><td colspan=2><br><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>const char *&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o0">name</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top><a class="el" href="structsdio__id__table.html">sdio_id_table</a> *&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o1">id_table</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o2">probe</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o3">remove</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o4">card_int_handler</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o5">suspend</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__func__driver.html#o6">resume</a> )(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)</td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
A driver for an SDIO function. 
<p>
<hr><h2>Field Documentation</h2>
<a class="anchor" name="o4" doxytag="sdio_func_driver::card_int_handler" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__func__driver.html#o4">sdio_func_driver::card_int_handler</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Called by the core to signal an SDIO interrupt for this card occurs, if interrupts have been enabled with <a class="el" href="group__fdriver.html#ga55">sdio_enable_interrupt()</a>.<p>
The driver's implementation should call <a class="el" href="group__fdriver.html#ga56">sdio_disable_interrupt()</a> and signal a thread (or similar) to actually handle the interrupt as no card I/O may be performed whilst in interrupt context. When the interrupt is handled, the driver should call <a class="el" href="group__fdriver.html#ga55">sdio_enable_interrupt()</a> to enable further interrupts to be signalled.<p>
<dl compact><dt><b><a class="el" href="bug.html#_bug000003">Bug:</a></b></dt><dd>This will <em>not</em> work correctly with cards with more than one function raising an interrupt. </dd></dl>
Called in: interrupt context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the device which may have raised the interrupt. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o1" doxytag="sdio_func_driver::id_table" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> struct <a class="el" href="structsdio__id__table.html">sdio_id_table</a>* <a class="el" href="structsdio__func__driver.html#o1">sdio_func_driver::id_table</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
0 terminated array of functions supported by this device.<p>
The driver may (for example) match on a number of vendor ID/device ID/function number triplets or on an SDIO standard interface.     </td>
  </tr>
</table>
<a class="anchor" name="o0" doxytag="sdio_func_driver::name" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> const char* <a class="el" href="structsdio__func__driver.html#o0">sdio_func_driver::name</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Driver name used in diagnostics.     </td>
  </tr>
</table>
<a class="anchor" name="o2" doxytag="sdio_func_driver::probe" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__func__driver.html#o2">sdio_func_driver::probe</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Called by the core when an inserted card has functions which match those listed in id_table.<p>
The driver's implementation should (if required):<p>
<ul>
<li>perform any additional probing</li><li>do function specific initialization</li><li>allocate and register any function/OS specific devices or interfaces.</li></ul>
<p>
Called in: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the newly inserted device.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o3" doxytag="sdio_func_driver::remove" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__func__driver.html#o3">sdio_func_driver::remove</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Called by the core when a card is removed. This is only called if the <a class="el" href="structsdio__func__driver.html#o2">probe()</a> call succeeded.<p>
The driver's implementation should (if required);<p>
<ul>
<li>do any function specific shutdown.</li><li>cleanup any data structures created/registers during <a class="el" href="structsdio__func__driver.html#o2">probe()</a>.</li></ul>
<p>
Called in: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the device being removed. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o6" doxytag="sdio_func_driver::resume" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__func__driver.html#o6">sdio_func_driver::resume</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Called by the core to signal a resume power management event occured.<p>
The driver's implementation should (if required) initialise the card to an operational mode and return as soon as possible. If the card has been powered off during suspend, the driver would have to initialise the card from scratch (f/w download, h/w initialisation, etc.).<p>
Called in: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the device handler. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o5" doxytag="sdio_func_driver::suspend" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__func__driver.html#o5">sdio_func_driver::suspend</a>)(struct <a class="el" href="structsdio__dev.html">sdio_dev</a> *fdev)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Called by the core to signal a suspend power management event occured.<p>
The driver's implementation should (if required) set the card to a low power mode and return as soon as possible. After this function returns, the driver should not start any SDIO commands.<p>
Called in: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>fdev</em>&nbsp;</td><td>the device handler. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<hr>The documentation for this struct was generated from the following file:<ul>
<li>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/<a class="el" href="sdio__api_8h-source.html">sdio_api.h</a></ul>
<hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
